import '/application_components/organism_components/schedule_visit_detail/schedule_visit_detail_widget.dart';
import '/application_components/organism_components/view_visit_detail/view_visit_detail_widget.dart';
import '/flutter_flow/flutter_flow_util.dart';
import 'package:flutter/material.dart';
import 'visit_details_modal_model.dart';
export 'visit_details_modal_model.dart';

class VisitDetailsModalWidget extends StatefulWidget {
  const VisitDetailsModalWidget({
    super.key,
    this.visitStatusStr,
    this.visitStartDateStr,
    this.visitEndDateStr,
    this.visitReasonStr,
    this.visitLevelStr,
    this.visitTempStr,
    this.visitObsStr,
    this.visitorStrList,
    this.visitorJsonList,
    this.visitorImgPath,
    this.visitorImgList,
    this.visitIdStr,
    this.updateToggleIdx,
    this.repeatVisitSchedule,
  });

  final String? visitStatusStr;
  final String? visitStartDateStr;
  final String? visitEndDateStr;
  final String? visitReasonStr;
  final String? visitLevelStr;
  final String? visitTempStr;
  final String? visitObsStr;
  final String? visitorStrList;
  final List<dynamic>? visitorJsonList;
  final String? visitorImgPath;
  final List<String>? visitorImgList;
  final String? visitIdStr;
  final Future Function()? updateToggleIdx;
  final Future Function()? repeatVisitSchedule;

  @override
  State<VisitDetailsModalWidget> createState() =>
      _VisitDetailsModalWidgetState();
}

class _VisitDetailsModalWidgetState extends State<VisitDetailsModalWidget> {
  late VisitDetailsModalModel _model;

  @override
  void setState(VoidCallback callback) {
    super.setState(callback);
    _model.onUpdate();
  }

  @override
  void initState() {
    super.initState();
    _model = createModel(context, () => VisitDetailsModalModel());
  }

  @override
  void dispose() {
    _model.maybeDispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Align(
      alignment: const AlignmentDirectional(0.0, 1.0),
      child: Builder(
        builder: (context) {
          if (widget.visitStatusStr != null && widget.visitStatusStr != '') {
            return wrapWithModel(
              model: _model.viewVisitDetailModel,
              updateCallback: () => setState(() {}),
              updateOnChange: true,
              child: ViewVisitDetailWidget(
                visitorImgPath: widget.visitorImgPath,
                visitStartDate: widget.visitStartDateStr!,
                visitEndDate: widget.visitEndDateStr!,
                visitReasonStr: widget.visitReasonStr!,
                visitLevelStr: widget.visitLevelStr!,
                visitTempStr: widget.visitTempStr!,
                visitObsStr: widget.visitObsStr!,
                visitStatusStr: widget.visitStatusStr!,
                visitorStrList: widget.visitorStrList!,
                visitorJsonList: widget.visitorJsonList,
                visitIdStr: widget.visitIdStr!,
                updateToggleIdx: () async {
                  await widget.updateToggleIdx?.call();
                },
                repeatVisitScheduleActionBlock: () async {
                  await widget.repeatVisitSchedule?.call();
                },
              ),
            );
          } else {
            return wrapWithModel(
              model: _model.scheduleVisitDetailModel,
              updateCallback: () => setState(() {}),
              updateOnChange: true,
              child: ScheduleVisitDetailWidget(
                visitorStrList: widget.visitorStrList!,
                visitorImgPath: widget.visitorImgPath,
                visitStartDate: widget.visitStartDateStr!,
                visitEndDate: widget.visitEndDateStr!,
                visitResonStr: widget.visitReasonStr!,
                visitLevelStr: widget.visitLevelStr!,
                visitTempStr: widget.visitTempStr!,
                visitObsStr: widget.visitObsStr!,
                visitorJsonList: widget.visitorJsonList!,
              ),
            );
          }
        },
      ),
    );
  }
}
